package p;

import atomicsets.OrderedLock;

/**
 * This should be made public as soon as possible.  It greatly simplifies
 * the task of implementing Map.
 */

class AbstractMap_SimpleEntry implements Map_Entry, atomicsets.Atomic {
public final OrderedLock getLockForF() {
		return $lock_F;
	}

	public final OrderedLock getLock() {
		return this.getLockForF();
	}

/*atomic(F)*/ private Object key;
/*atomic(F)*/ private Object value;

public AbstractMap_SimpleEntry(Object key, Object value) {
	this(key, value, new OrderedLock());
}

public AbstractMap_SimpleEntry(Object key, Object value, OrderedLock F) {
    $lock_F = F;
	this.key   = key;
        this.value = value;
}

public AbstractMap_SimpleEntry(Map_Entry e) {
	this(e, new OrderedLock());
}

public AbstractMap_SimpleEntry(Map_Entry e, OrderedLock F) {
    $lock_F = F;
	this.key   = e.getKey();
        this.value = e.getValue();
}

public Object getKey_internal() {
    return key;
}

public Object getKey() {
	synchronized (this.$lock_F) {
		return key;
	}
}

public Object getValue_internal() {
    return value;
}

public Object getValue() {
	synchronized (this.$lock_F) {
		return value;
	}
}

public Object setValue_internal(Object value) {
    Object oldValue = this.value;
    this.value = value;
    return oldValue;
}

public Object setValue(Object value) {
	synchronized (this.$lock_F) {
		Object oldValue = this.value;
		this.value = value;
		return oldValue;
	}
}

public boolean equals_internal(/*unitfor*/ Object o) {
    if (!(o instanceof Map_Entry))
	return false;
    Map_Entry e = (Map_Entry)o;
    return eq(key, e.getKey()) && eq(value, e.getValue());
}

public boolean equals(Object o) {
	if (!(o instanceof Map_Entry))
	return false;
	Map_Entry e = (Map_Entry)o;
	OrderedLock l1 = null, l2 = null;
	{
		OrderedLock l3 = ((atomicsets.Atomic) o).getLock();
		OrderedLock l4 = this.$lock_F;
		if (l3.getIndex() > l4.getIndex()) {
			l1 = l3;
			l2 = l4;
		} else {
			l1 = l4;
			l2 = l3;
		}
	}
	synchronized (l1) {
		synchronized (l2) {
			return eq(key, e.getKey()) && eq(value, e.getValue());
		}
	}
}

public int hashCode_internal() {
    return ((key   == null)   ? 0 :   key.hashCode()) ^
	   ((value == null)   ? 0 : value.hashCode());
}

public int hashCode() {
	synchronized (this.$lock_F) {
		return ((key   == null)   ? 0 :   key.hashCode()) ^
		   ((value == null)   ? 0 : value.hashCode());
	}
}

public String toString_internal() {
    return key + "=" + value;
}

public String toString() {
	synchronized (this.$lock_F) {
		return key + "=" + value;
	}
}

    private static boolean eq(Object o1, Object o2) {
        return (o1 == null ? o2 == null : o1.equals(o2));
    }

	protected final OrderedLock $lock_F;
}