/**
 * 
 */
package p;

import atomicsets.OrderedLock;

class HashMap_Entry implements Map_Entry, atomicsets.Atomic {
    public final OrderedLock getLockForF() {
		return $lock_F;
	}

	public final OrderedLock getLock() {
		return this.getLockForF();
	}

	/*atomic(F)*/ private final Object key;
    /*atomic(F)*/ private Object value;
    /*atomic(F)*/ private final int hash;
    /*atomic(F)*/ private HashMap_Entry next/*F=this.F*/;

    /**
	 * Create new entry.
	 */
	HashMap_Entry(int h, Object k, Object v, HashMap_Entry n) {
		this(h, k, v, n, new OrderedLock());
	}

	/**
     * Create new entry.
     */
    HashMap_Entry(int h, Object k, Object v, HashMap_Entry n/*F=this.F*/, OrderedLock F) {
        $lock_F = F;
		value = v;
        next = n;
        key = k;
        hash = h;
    }

    public Object getKey_internal() {
        return HashMap.unmaskNull(key);
    }

	public Object getKey() {
		synchronized (this.$lock_F) {
			return HashMap.unmaskNull(key);
		}
	}

    public Object getValue_internal() {
        return value;
    }

	public Object getValue() {
		synchronized (this.$lock_F) {
			return value;
		}
	}

    public HashMap_Entry/*F=this.F*/ getNext_internal(){
    	return next;
    }

	public HashMap_Entry getNext() {
		synchronized (this.$lock_F) {
			return next;
		}
	}
    
    public void setNext_internal(HashMap_Entry/*F=this.F*/ n){
    	this.next = n;
    }

	public void setNext(HashMap_Entry n) {
		synchronized (this.$lock_F) {
			this.next = n;
		}
	}
    
    public int getHash_internal(){
    	return hash;
    }

	public int getHash() {
    	return hash;
    }
    
    public Object setValue_internal(Object newValue) {
    Object oldValue = value;
        value = newValue;
        return oldValue;
    }

	public Object setValue(Object newValue) {
		synchronized (this.$lock_F) {
			Object oldValue = value;
			value = newValue;
			return oldValue;
		}
	}

    public boolean equals_internal(/*unitfor*/ Object o) {
        if (!(o instanceof Map_Entry))
            return false;
        Map_Entry e = (Map_Entry)o;
        Object k1 = getKey_internal();
        Object k2 = e.getKey();
        if (k1 == k2 || (k1 != null && k1.equals(k2))) {
            Object v1 = getValue_internal();
            Object v2 = e.getValue();
            if (v1 == v2 || (v1 != null && v1.equals(v2))) 
                return true;
        }
        return false;
    }

	public boolean equals(Object o) {
		if (!(o instanceof Map_Entry))
            return false;
		Map_Entry e = (Map_Entry)o;
		OrderedLock l1 = null, l2 = null;
		{
			OrderedLock l3 = ((atomicsets.Atomic) o).getLock();
			OrderedLock l4 = this.$lock_F;
			if (l3.getIndex() > l4.getIndex()) {
				l1 = l3;
				l2 = l4;
			} else {
				l1 = l4;
				l2 = l3;
			}
		}
		synchronized (l1) {
			synchronized (l2) {
				Object k1 = getKey_internal();
				Object k2 = e.getKey();
				if (k1 == k2 || (k1 != null && k1.equals(k2))) {
				    Object v1 = getValue_internal();
				    Object v2 = e.getValue();
				    if (v1 == v2 || (v1 != null && v1.equals(v2))) 
				        return true;
				}
			}
		}
		return false;
	}

    public int hashCode_internal() {
        return (key==HashMap.NULL_KEY ? 0 : key.hashCode()) ^
               (value==null   ? 0 : value.hashCode());
    }

	public int hashCode() {
		synchronized (this.$lock_F) {
			return (key==HashMap.NULL_KEY ? 0 : key.hashCode()) ^
			       (value==null   ? 0 : value.hashCode());
		}
	}

    public String toString_internal() {
        return getKey_internal() + "=" + getValue_internal();
    }

	public String toString() {
		synchronized (this.$lock_F) {
			return getKey_internal() + "=" + getValue_internal();
		}
	}

    /**
     * This method is invoked whenever the value in an entry is
     * overwritten by an invocation of put(k,v) for a key k that's already
     * in the HashMap.
     */
    void recordAccess_internal(HashMap/*M=this.F*/ m) {
    }

	/**
	 * This method is invoked whenever the value in an entry is overwritten by an invocation of put(k,v) for a key k that's already in the HashMap.
	 */
	void recordAccess(HashMap m) {
    }

    /**
     * This method is invoked whenever the entry is
     * removed from the table.
     */
    void recordRemoval_internal(HashMap/*M=this.F*/ m) {
    }

	/**
	 * This method is invoked whenever the entry is removed from the table.
	 */
	void recordRemoval(HashMap m) {
    }

	protected final OrderedLock $lock_F;
}