/**
 * 
 */
package p;

import atomicsets.OrderedLock;

class HashMap_EntrySet extends AbstractSet/*<Map.Entry>*/ {
    /**
	 * 
	 */
	/*atomic(L)*/ private final HashMap hashMap/*M=this.L*/;
	/**
	 * @param map
	 */
	HashMap_EntrySet(HashMap map) {
		this(map, new OrderedLock());
	}
	/**
	 * @param map
	 */
	HashMap_EntrySet(HashMap map/*M=this.L*/, OrderedLock L) {
		super(L);
		hashMap = map;
	}
	public Iterator/*<Map.Entry>*/ iterator_internal() {
        return hashMap.newEntryIterator_internal();
    }
	public Iterator iterator() {
		synchronized (this.$lock_L) {
			return hashMap.newEntryIterator_internal();
		}
	}
    public boolean contains_internal(Object o) {
        if (!(o instanceof Map_Entry))
            return false;
        Map_Entry e = (Map_Entry) o;
        HashMap_Entry candidate/*F=this.L*/ = hashMap.getEntry_internal(e.getKey());
        return candidate != null && candidate.equals(e);
    }
	public boolean contains(Object o) {
		if (!(o instanceof Map_Entry))
            return false;
		Map_Entry e = (Map_Entry) o;
		synchronized (this.$lock_L) {
			HashMap_Entry candidate/*F=this.L*/ = hashMap.getEntry_internal(e.getKey());
			return candidate != null && candidate.equals(e);
		}
	}
    public boolean remove_internal(Object o) {
        return hashMap.removeMapping_internal(o) != null;
    }
	public boolean remove(Object o) {
		synchronized (this.$lock_L) {
			return hashMap.removeMapping_internal(o) != null;
		}
	}
    public int size_internal() {
        return hashMap.getSize_internal();
    }
	public int size() {
		synchronized (this.$lock_L) {
			return hashMap.getSize_internal();
		}
	}
    public void clear_internal() {
        hashMap.clear_internal();
    }
	public void clear() {
		synchronized (this.$lock_L) {
			hashMap.clear_internal();
		}
	}
}