/**
 * 
 */
package p;

import atomicsets.OrderedLock;

abstract class HashMap_HashIterator implements Iterator, atomicsets.Atomic {
    public final OrderedLock getLockForI() {
		return $lock_I;
	}

	public final OrderedLock getLock() {
		return this.getLockForI();
	}

	/*atomic(I)*/ private HashMap_Entry next/*F=this.I*/;	// next entry to return
    /*atomic(I)*/ private int expectedModCount;	// For fast-fail 
    /*atomic(I)*/ private int index;		// current slot 
    /*atomic(I)*/ private HashMap_Entry current/*F=this.I*/;	// current entry
    /*atomic(I)*/ private final HashMap hashMap/*M=this.I*/;
    
    HashMap_HashIterator(HashMap hm) {
		this(hm, new OrderedLock());
	}

	HashMap_HashIterator(HashMap/*M=this.I*/ hm, OrderedLock I) {
    	$lock_I = I;
		hashMap = hm;
        expectedModCount = hashMap.getModCount_internal();
        HashMap_Entry[] t/*this.I[]F=this.I*/ = hashMap.getTable_internal();
        int i = t.length;
        HashMap_Entry n/*F=this.I*/ = null;
        if (hashMap.getSize_internal() != 0) { // advance to first entry
            while (i > 0 && (n = t[--i]) == null)
                ;
        } 
        next = n;   
        index = i; 
    }

    public boolean hasNext_internal() {
        return next != null;
    }

	public boolean hasNext() {
		synchronized (this.$lock_I) {
			return next != null;
		}
	}

    HashMap_Entry/*F=this.I*/ nextEntry_internal() { 
        if (hashMap.getModCount_internal() != expectedModCount)
            throw new ConcurrentModificationException();
        HashMap_Entry e/*F=this.I*/ = next;
        if (e == null) 
            throw new NoSuchElementException();
            
        HashMap_Entry n/*F=this.I*/ = e.getNext_internal();
        HashMap_Entry[] t/*this.I[]F=this.I*/  = hashMap.getTable_internal();
        int i = index;
        while (n == null && i > 0)
            n = t[--i];
        index = i;
        next = n;
        return current = e;
    }

	HashMap_Entry nextEntry() {
		synchronized (this.$lock_I) {
			if (hashMap.getModCount_internal() != expectedModCount)
			    throw new ConcurrentModificationException();
			HashMap_Entry e/*F=this.I*/ = next;
			if (e == null) 
			    throw new NoSuchElementException();
			HashMap_Entry n/*F=this.I*/ = e.getNext_internal();
			HashMap_Entry[] t/*this.I[]F=this.I*/  = hashMap.getTable_internal();
			int i = index;
			while (n == null && i > 0)
			    n = t[--i];
			index = i;
			next = n;
			return current = e;
		}
	}

    public void remove_internal() {
        if (current == null)
            throw new IllegalStateException();
        if (hashMap.getModCount_internal() != expectedModCount)
            throw new ConcurrentModificationException();
        Object k = current.getKey_internal();
        current = null;
        hashMap.removeEntryForKey_internal(k);
        expectedModCount = hashMap.getModCount_internal();
    }

	public void remove() {
		synchronized (this.$lock_I) {
			if (current == null)
			    throw new IllegalStateException();
			if (hashMap.getModCount_internal() != expectedModCount)
			    throw new ConcurrentModificationException();
			Object k = current.getKey_internal();
			current = null;
			hashMap.removeEntryForKey_internal(k);
			expectedModCount = hashMap.getModCount_internal();
		}
	}

	protected final OrderedLock $lock_I;

}