/**
 * 
 */
package p;

import atomicsets.OrderedLock;

abstract class LinkedHashMap_LinkedHashIterator implements Iterator, atomicsets.Atomic {

public final OrderedLock getLockForI() {
		return $lock_I;
	}

	public final OrderedLock getLock() {
		return this.getLockForI();
	}

/*atomic(I)*/ private final LinkedHashMap linkedHashMap/*M=this.I*/;
/*atomic(I)*/ private final LinkedHashMap_Entry header/*F=this.I*/;	// FT: introduced to avoid direct field acc

	
public LinkedHashMap_LinkedHashIterator(LinkedHashMap lhm, LinkedHashMap_Entry h) {
	this(lhm, h, new OrderedLock());
}

public LinkedHashMap_LinkedHashIterator(LinkedHashMap lhm/*M=this.I*/, LinkedHashMap_Entry h/*F=this.I*/, OrderedLock I){
	$lock_I = I;
	this.header = h;
	linkedHashMap = lhm;
	nextEntry    = header.getAfter_internal();
	expectedModCount = linkedHashMap.getModCount_internal();
}
	
/*atomic(I)*/ private LinkedHashMap_Entry nextEntry/*F=this.I*/;
/*atomic(I)*/ private LinkedHashMap_Entry lastReturned/*F=this.I*/ = null;

/**
 * The modCount value that the iterator believes that the backing
 * List should have.  If this expectation is violated, the iterator
 * has detected concurrent modification.
 */
/*atomic(I)*/ private int expectedModCount;

public boolean hasNext_internal() {
        return nextEntry != header;
}

public boolean hasNext() {
	synchronized (this.$lock_I) {
		return nextEntry != header;
	}
}

public void remove_internal() {
    if (lastReturned == null)
	throw new IllegalStateException();
    if (linkedHashMap.getModCount_internal() != expectedModCount)
	throw new ConcurrentModificationException();

    linkedHashMap.remove_internal(lastReturned.getKey_internal());
        lastReturned = null;
        expectedModCount = linkedHashMap.getModCount_internal();
}

public void remove() {
	synchronized (this.$lock_I) {
		if (lastReturned == null)
		throw new IllegalStateException();
		if (linkedHashMap.getModCount_internal() != expectedModCount)
		throw new ConcurrentModificationException();
		linkedHashMap.remove_internal(lastReturned.getKey_internal());
		lastReturned = null;
		expectedModCount = linkedHashMap.getModCount_internal();
	}
}

LinkedHashMap_Entry/*F=this.I*/ nextEntry_internal() {
    if (linkedHashMap.getModCount_internal() != expectedModCount)
	throw new ConcurrentModificationException();
        if (nextEntry == header)
            throw new NoSuchElementException();

        LinkedHashMap_Entry e/*F=this.I*/ = lastReturned = nextEntry;
        nextEntry = e.getAfter_internal();
        return e;
}

LinkedHashMap_Entry nextEntry() {
	synchronized (this.$lock_I) {
		if (linkedHashMap.getModCount_internal() != expectedModCount)
		throw new ConcurrentModificationException();
		if (nextEntry == header)
            throw new NoSuchElementException();
		LinkedHashMap_Entry e/*F=this.I*/ = lastReturned = nextEntry;
		nextEntry = e.getAfter_internal();
		return e;
	}
}

protected final OrderedLock $lock_I;
}