/**
 * 
 */
package p;

import atomicsets.OrderedLock;

class LinkedList_ListItr implements ListIterator, atomicsets.Atomic {
	
	public final OrderedLock getLockForI() {
		return $lock_I;
	}

	public final OrderedLock getLock() {
		return this.getLockForI();
	}

	/*atomic(I)*/ private final LinkedList linkedList/*L=this.I*/;	
	/*atomic(I)*/ private final LinkedList_Entry header/*E=this.I*/;
	/*atomic(I)*/ private LinkedList_Entry lastReturned/*E=this.I*/;
	/*atomic(I)*/ private LinkedList_Entry next/*E=this.I*/;
	/*atomic(I)*/ private int nextIndex;
	/*atomic(I)*/ private int expectedModCount;

LinkedList_ListItr(LinkedList ll, LinkedList_Entry h, int index) {
		this(ll, h, index, new OrderedLock());
	}

LinkedList_ListItr(LinkedList ll/*L=this.I*/,LinkedList_Entry h/*E=this.I*/, int index, OrderedLock I) {
	$lock_I = I;
	header = h;
	this.linkedList = ll;
	lastReturned = header;
	expectedModCount = linkedList.getModCount_internal();
    if (index < 0 || index > linkedList.getSize_internal())
	throw new IndexOutOfBoundsException("Index: "+index+
					    ", Size: "+linkedList.getSize_internal());
    if (index < (linkedList.getSize_internal() >> 1)) {
	next = header.next;
	for (nextIndex=0; nextIndex<index; nextIndex++)
	    next = next.next;
    } else {
	next = header;
	for (nextIndex=linkedList.getSize_internal(); nextIndex>index; nextIndex--)
	    next = next.previous;
    }
}

public boolean hasNext_internal() {
    return nextIndex != linkedList.getSize_internal();
}

public boolean hasNext() {
	synchronized (this.$lock_I) {
		return nextIndex != linkedList.getSize_internal();
	}
}

public Object next_internal() {
    checkForComodification_internal();
    if (nextIndex == linkedList.getSize_internal())
	throw new NoSuchElementException();

    lastReturned = next;
    next = next.next;
    nextIndex++;
    return lastReturned.element;
}

public Object next() {
	synchronized (this.$lock_I) {
		checkForComodification_internal();
		if (nextIndex == linkedList.getSize_internal())
		throw new NoSuchElementException();
		lastReturned = next;
		next = next.next;
		nextIndex++;
		return lastReturned.element;
	}
}

public boolean hasPrevious_internal() {
    return nextIndex != 0;
}

public boolean hasPrevious() {
	synchronized (this.$lock_I) {
		return nextIndex != 0;
	}
}

public Object previous_internal() {
    if (nextIndex == 0)
	throw new NoSuchElementException();

    lastReturned = next = next.previous;
    nextIndex--;
    checkForComodification_internal();
    return lastReturned.element;
}

public Object previous() {
	synchronized (this.$lock_I) {
		if (nextIndex == 0)
		throw new NoSuchElementException();
		lastReturned = next = next.previous;
		nextIndex--;
		checkForComodification_internal();
		return lastReturned.element;
	}
}

public int nextIndex_internal() {
    return nextIndex;
}

public int nextIndex() {
	synchronized (this.$lock_I) {
		return nextIndex;
	}
}

public int previousIndex_internal() {
    return nextIndex-1;
}

public int previousIndex() {
	synchronized (this.$lock_I) {
		return nextIndex-1;
	}
}

public void remove_internal() {
        checkForComodification_internal();
        LinkedList_Entry lastNext/*E=this.I*/ = lastReturned.next;
        try {
        	linkedList.remove_internal(lastReturned);
        } catch (NoSuchElementException e) {
            throw new IllegalStateException();
        }
    if (next==lastReturned)
            next = lastNext;
        else
	nextIndex--;
    lastReturned = header;
    expectedModCount++;
}

public void remove() {
	synchronized (this.$lock_I) {
		checkForComodification_internal();
		LinkedList_Entry lastNext/*E=this.I*/ = lastReturned.next;
		try {
        	linkedList.remove_internal(lastReturned);
        } catch (NoSuchElementException e) {
            throw new IllegalStateException();
        }
		if (next==lastReturned)
		        next = lastNext;
		    else
		nextIndex--;
		lastReturned = header;
		expectedModCount++;
	}
}

public void set_internal(Object o) {
    if (lastReturned == header)
	throw new IllegalStateException();
    checkForComodification_internal();
    lastReturned.element = o;
}

public void set(Object o) {
	synchronized (this.$lock_I) {
		if (lastReturned == header)
		throw new IllegalStateException();
		checkForComodification_internal();
		lastReturned.element = o;
	}
}

public void add_internal(Object o) {
    checkForComodification_internal();
    lastReturned = header;
    linkedList.addBefore2_internal(o, next);
    nextIndex++;
    expectedModCount++;
}

public void add(Object o) {
	synchronized (this.$lock_I) {
		checkForComodification_internal();
		lastReturned = header;
		linkedList.addBefore2_internal(o, next);
		nextIndex++;
		expectedModCount++;
	}
}

final void checkForComodification_internal() {
    if (linkedList.getModCount_internal() != expectedModCount)
	throw new ConcurrentModificationException();
}

final void checkForComodification() {
	synchronized (this.$lock_I) {
		if (linkedList.getModCount_internal() != expectedModCount)
		throw new ConcurrentModificationException();
	}
}

protected final OrderedLock $lock_I;
}