/**
 * 
 */
package p;

import atomicsets.OrderedLock;

class TreeMap_3 extends AbstractSet {
	
	/*atomic(L)*/private final TreeMap treeMap/*M=this.L*/;
	
	public TreeMap_3(TreeMap tm) {
		this(tm, new OrderedLock());
	}

	public TreeMap_3(TreeMap tm/*M=this.L*/, OrderedLock L){
		super(L);
		this.treeMap = tm;
	}
	
	public Iterator iterator_internal() {
        return (Iterator) new TreeMap_EntryIterator/*I=this.L*/(treeMap, this.$lock_L);
    }

	public Iterator iterator() {
		synchronized (this.$lock_L) {
			return (Iterator) new TreeMap_EntryIterator/*I=this.L*/(treeMap, this.$lock_L);
		}
	}

    public boolean contains_internal(Object o) {
        if (!(o instanceof Map_Entry))
            return false;
        Map_Entry entry = (Map_Entry) o;
        Object value = entry.getValue();
        TreeMap_Entry p/*F=this.L*/ = treeMap.getEntry_internal(entry.getKey());
        return p != null && TreeMap.valEquals(p.getValue_internal(), value);
    }

	public boolean contains(Object o) {
		if (!(o instanceof Map_Entry))
            return false;
		Map_Entry entry = (Map_Entry) o;
		synchronized (this.$lock_L) {
			Object value = entry.getValue();
			TreeMap_Entry p/*F=this.L*/ = treeMap.getEntry_internal(entry.getKey());
			return p != null && TreeMap.valEquals(p.getValue_internal(), value);
		}
	}

    public boolean remove_internal(Object o) {
        if (!(o instanceof Map_Entry))
            return false;
        Map_Entry entry = (Map_Entry) o;
        Object value = entry.getValue();
        TreeMap_Entry p/*F=this.L*/ = treeMap.getEntry_internal(entry.getKey());
        if (p != null && TreeMap.valEquals(p.getValue_internal(), value)) {
        	treeMap.deleteEntry_internal(p);
            return true;
        }
        return false;
    }

	public boolean remove(Object o) {
		if (!(o instanceof Map_Entry))
            return false;
		Map_Entry entry = (Map_Entry) o;
		synchronized (this.$lock_L) {
			Object value = entry.getValue();
			TreeMap_Entry p/*F=this.L*/ = treeMap.getEntry_internal(entry.getKey());
			if (p != null && TreeMap.valEquals(p.getValue_internal(), value)) {
				treeMap.deleteEntry_internal(p);
			    return true;
			}
		}
		return false;
	}

    public int size_internal() {
        return treeMap.size_internal();
    }

	public int size() {
		synchronized (this.$lock_L) {
			return treeMap.size_internal();
		}
	}

    public void clear_internal() {
    	treeMap.clear_internal();
    }

	public void clear() {
		synchronized (this.$lock_L) {
			treeMap.clear_internal();
		}
	}
}