/**
 * 
 */
package p;

import atomicsets.OrderedLock;

class TreeMap_EntrySetView extends AbstractSet {
	
	/*atomic(L)*/ private final TreeMap_SubMap treeMapSubMap/*M=this.L*/;
	
	public TreeMap_EntrySetView(TreeMap_SubMap tmsm) {
		this(tmsm, new OrderedLock());
	}

	public TreeMap_EntrySetView(TreeMap_SubMap tmsm/*M=this.L*/, OrderedLock L){
		super(L);
		treeMapSubMap = tmsm;
	}
	
	/*atomic(L)*/ private transient int size = -1;
	/*atomic(L)*/ private transient int sizeModCount;

    public int size_internal() {
        if (size == -1 || sizeModCount != treeMapSubMap.getTreeMap_internal().getModCount_internal()) {
            size = 0;  sizeModCount = treeMapSubMap.getTreeMap_internal().getModCount_internal();
            Iterator i = iterator_internal();
            while (i.hasNext()) {
                size++;
                i.next();
            }
        }
        return size;
    }

	public int size() {
		synchronized (this.$lock_L) {
			if (size == -1 || sizeModCount != treeMapSubMap.getTreeMap_internal().getModCount_internal()) {
			    size = 0;  sizeModCount = treeMapSubMap.getTreeMap_internal().getModCount_internal();
			    Iterator i = iterator_internal();
			    while (i.hasNext()) {
			        size++;
			        i.next();
			    }
			}
			return size;
		}
	}

    public boolean isEmpty_internal() {
        return !iterator_internal().hasNext();
    }

	public boolean isEmpty() {
		synchronized (this.$lock_L) {
			return !iterator_internal().hasNext();
		}
	}

    public boolean contains_internal(Object o) {
        if (!(o instanceof Map_Entry))
            return false;
        Map_Entry entry = (Map_Entry) o;
        Object key = entry.getKey();
        if (!treeMapSubMap.inRange_internal(key))
            return false;
        TreeMap_Entry node/*F=this.L*/ = treeMapSubMap.getTreeMap_internal().getEntry_internal(key);
        return node != null &&
               TreeMap.valEquals(node.getValue_internal(), entry.getValue());
    }

	public boolean contains(Object o) {
		if (!(o instanceof Map_Entry))
            return false;
		Map_Entry entry = (Map_Entry) o;
		synchronized (this.$lock_L) {
			Object key = entry.getKey();
			if (!treeMapSubMap.inRange_internal(key))
			    return false;
			TreeMap_Entry node/*F=this.L*/ = treeMapSubMap.getTreeMap_internal().getEntry_internal(key);
			return node != null &&
			       TreeMap.valEquals(node.getValue_internal(), entry.getValue());
		}
	}

    public boolean remove_internal(Object o) {
        if (!(o instanceof Map_Entry))
            return false;
        Map_Entry entry = (Map_Entry) o;
        Object key = entry.getKey();
        if (!treeMapSubMap.inRange_internal(key))
            return false;
        TreeMap_Entry node/*F=this.L*/ = treeMapSubMap.getTreeMap_internal().getEntry_internal(key);
        if (node!=null && TreeMap.valEquals(node.getValue_internal(),entry.getValue())){
        	treeMapSubMap.getTreeMap_internal().deleteEntry_internal(node);
            return true;
        }
        return false;
    }

	public boolean remove(Object o) {
		if (!(o instanceof Map_Entry))
            return false;
		Map_Entry entry = (Map_Entry) o;
		synchronized (this.$lock_L) {
			Object key = entry.getKey();
			if (!treeMapSubMap.inRange_internal(key))
			    return false;
			TreeMap_Entry node/*F=this.L*/ = treeMapSubMap.getTreeMap_internal().getEntry_internal(key);
			if (node!=null && TreeMap.valEquals(node.getValue_internal(),entry.getValue())){
				treeMapSubMap.getTreeMap_internal().deleteEntry_internal(node);
			    return true;
			}
		}
		return false;
	}

    public Iterator iterator_internal() {
        return (Iterator) new TreeMap_SubMapEntryIterator/*I=this.L*/(treeMapSubMap.getTreeMap_internal(),
            (treeMapSubMap.getFromStart_internal() ? treeMapSubMap.getTreeMap_internal().firstEntry_internal() : treeMapSubMap.getTreeMap_internal().getCeilEntry_internal(treeMapSubMap.getFromKey_internal())),
            (treeMapSubMap.getToEnd_internal()     ? null         : treeMapSubMap.getTreeMap_internal().getCeilEntry_internal(treeMapSubMap.getToKey_internal())), this.$lock_L);
    }

	public Iterator iterator() {
		synchronized (this.$lock_L) {
			return (Iterator) new TreeMap_SubMapEntryIterator/*I=this.L*/(treeMapSubMap.getTreeMap_internal(),
			    (treeMapSubMap.getFromStart_internal() ? treeMapSubMap.getTreeMap_internal().firstEntry_internal() : treeMapSubMap.getTreeMap_internal().getCeilEntry_internal(treeMapSubMap.getFromKey_internal())),
			    (treeMapSubMap.getToEnd_internal()     ? null         : treeMapSubMap.getTreeMap_internal().getCeilEntry_internal(treeMapSubMap.getToKey_internal())), this.$lock_L);
		}
	}
}