package p;

import atomicsets.OrderedLock;

/**
 * TreeMap Iterator.
 */
abstract class TreeMap_PrivateEntryIterator implements Iterator, atomicsets.Atomic {
	
	public final OrderedLock getLockForI() {
		return $lock_I;
	}

	public final OrderedLock getLock() {
		return this.getLockForI();
	}

	/*atomic(I)*/ private final TreeMap treeMap/*M=this.I*/;
	/*atomic(I)*/ private int expectedModCount;
	/*atomic(I)*/ private TreeMap_Entry lastReturned/*F=this.I*/ = null;
	/*atomic(I)*/ private TreeMap_Entry next/*F=this.I*/;

	public TreeMap_Entry/*F=this.I*/ getNext_internal(){ // FT: added
		return next;
	}

	public TreeMap_Entry getNext() {
		synchronized (this.$lock_I) {
			return next;
		}
	}
	
    TreeMap_PrivateEntryIterator(TreeMap tm) {
		this(tm, new OrderedLock());
	}

	TreeMap_PrivateEntryIterator(TreeMap tm/*M=this.I*/, OrderedLock I) {
    	$lock_I = I;
		this.treeMap = tm;
    	expectedModCount = treeMap.getModCount_internal();
        next = treeMap.firstEntry_internal();
    }

    TreeMap_PrivateEntryIterator(TreeMap tm, TreeMap_Entry first) {
		this(tm, first, new OrderedLock());
	}

	// Used by SubMapEntryIterator
    TreeMap_PrivateEntryIterator(TreeMap tm/*M=this.I*/, TreeMap_Entry first/*F=this.I*/, OrderedLock I) {
    	$lock_I = I;
		this.treeMap = tm;
    	expectedModCount = treeMap.getModCount_internal();
        next = first;
    }

    public boolean hasNext_internal() {
        return next != null;
    }

	public boolean hasNext() {
		synchronized (this.$lock_I) {
			return next != null;
		}
	}

    final TreeMap_Entry/*F=this.I*/ nextEntry_internal() {
        if (next == null)
            throw new NoSuchElementException();
        if (treeMap.getModCount_internal() != expectedModCount)
            throw new ConcurrentModificationException();
        lastReturned = next;
        next = treeMap.successor_internal(next);
        return lastReturned;
    }

	final TreeMap_Entry nextEntry() {
		synchronized (this.$lock_I) {
			if (next == null)
			    throw new NoSuchElementException();
			if (treeMap.getModCount_internal() != expectedModCount)
			    throw new ConcurrentModificationException();
			lastReturned = next;
			next = treeMap.successor_internal(next);
			return lastReturned;
		}
	}

    public void remove_internal() {
        if (lastReturned == null)
            throw new IllegalStateException();
        if (treeMap.getModCount_internal() != expectedModCount)
            throw new ConcurrentModificationException();
        if (lastReturned.getLeft_internal() != null && lastReturned.getRight_internal() != null)
            next = lastReturned;
        treeMap.deleteEntry_internal(lastReturned);
        expectedModCount++;
        lastReturned = null;
    }

	public void remove() {
		synchronized (this.$lock_I) {
			if (lastReturned == null)
			    throw new IllegalStateException();
			if (treeMap.getModCount_internal() != expectedModCount)
			    throw new ConcurrentModificationException();
			if (lastReturned.getLeft_internal() != null && lastReturned.getRight_internal() != null)
			    next = lastReturned;
			treeMap.deleteEntry_internal(lastReturned);
			expectedModCount++;
			lastReturned = null;
		}
	}

	protected final OrderedLock $lock_I;
}