/**
 * 
 */
package p;

import atomicsets.OrderedLock;



class TreeMap_SubMap
extends AbstractMap
implements SortedMap, java.io.Serializable {
	
	/*atomic(M)*/ private final TreeMap treeMap/*M=this.M*/;
	
	/*atomic(M)*/ private static final long serialVersionUID = -6520786458950516097L;

	/*atomic(M)*/ private boolean toEnd;

	/*atomic(M)*/ private boolean fromStart;

	/*atomic(M)*/ private Object fromKey;

	/*atomic(M)*/ private Object toKey;

	public TreeMap/*M=this.M*/ getTreeMap_internal(){ // FT: added
		return treeMap;
	}

	public TreeMap getTreeMap() { // FT: added
		return treeMap;
	}
	
	public boolean getFromStart_internal(){ // FT: added
		return fromStart;
	}

	public boolean getFromStart() {
		synchronized (this.$lock_M) {
			return fromStart;
		}
	}
	
	public boolean getToEnd_internal(){ // FT: added
		return toEnd;
	}

	public boolean getToEnd() {
		synchronized (this.$lock_M) {
			return toEnd;
		}
	}
	
	public Object getFromKey_internal(){ // FT: added
		return fromKey;
	}

	public Object getFromKey() {
		synchronized (this.$lock_M) {
			return fromKey;
		}
	}
	
	public Object getToKey_internal(){ // FT: added
		return toKey;
	}

	public Object getToKey() {
		synchronized (this.$lock_M) {
			return toKey;
		}
	}
	
	TreeMap_SubMap(TreeMap tm, Object fromKey, Object toKey) {
		this(tm, fromKey, toKey, new OrderedLock());
	}

	TreeMap_SubMap(TreeMap tm/*M=this.M*/, Object fromKey, Object toKey, OrderedLock M) {
    	super(M);
		treeMap = tm;
        if (treeMap.compare_internal(fromKey, toKey) > 0)
            throw new IllegalArgumentException("fromKey > toKey");
        this.fromKey = fromKey;
        this.toKey = toKey;
    }

    TreeMap_SubMap(TreeMap tm, Object key, boolean headMap) {
		this(tm, key, headMap, new OrderedLock());
	}

	TreeMap_SubMap(TreeMap tm/*M=this.M*/, Object key, boolean headMap, OrderedLock M) {
    	super(M);
		treeMap = tm;
        treeMap.compare_internal(key, key); // Type-check key

        if (headMap) {
            fromStart = true;
            toKey = key;
        } else {
            toEnd = true;
            fromKey = key;
        }
    }

    TreeMap_SubMap(TreeMap tm, boolean fromStart, Object fromKey,
			boolean toEnd, Object toKey) {
		this(tm, fromStart, fromKey, toEnd, toKey, new OrderedLock());
	}

	TreeMap_SubMap(TreeMap tm/*M=this.M*/, boolean fromStart, Object fromKey, boolean toEnd, Object toKey, OrderedLock M) {
    	super(M);
		treeMap = tm;
        this.fromStart = fromStart;
        this.fromKey= fromKey;
        this.toEnd = toEnd;
        this.toKey = toKey;
    }

    public boolean isEmpty_internal() {
        return entrySet.isEmpty_internal();
    }

	public boolean isEmpty() {
		synchronized (this.$lock_M) {
			return entrySet.isEmpty_internal();
		}
	}

    public boolean containsKey_internal(Object key) {
        return inRange_internal((Object) key) && treeMap.containsKey_internal(key);
    }

	public boolean containsKey(Object key) {
		synchronized (this.$lock_M) {
			return inRange_internal((Object) key) && treeMap.containsKey_internal(key);
		}
	}

    public Object get_internal(Object key) {
        if (!inRange_internal((Object) key))
            return null;
        return treeMap.get_internal(key);
    }

	public Object get(Object key) {
		synchronized (this.$lock_M) {
			if (!inRange_internal((Object) key))
			    return null;
			return treeMap.get_internal(key);
		}
	}

    public Object put_internal(Object key, Object value) {
        if (!inRange_internal(key))
            throw new IllegalArgumentException("key out of range");
        return treeMap.put_internal(key, value);
    }

	public Object put(Object key, Object value) {
		synchronized (this.$lock_M) {
			if (!inRange_internal(key))
			    throw new IllegalArgumentException("key out of range");
			return treeMap.put_internal(key, value);
		}
	}

    public Comparator comparator_internal() {
        return treeMap.getComparator_internal();
    }

	public Comparator comparator() {
		synchronized (this.$lock_M) {
			return treeMap.getComparator_internal();
		}
	}

    public Object firstKey_internal() {
    TreeMap_Entry e/*F=this.M*/ = fromStart ? treeMap.firstEntry_internal() : treeMap.getCeilEntry_internal(fromKey);
        Object first = TreeMap.key(e);
        if (!toEnd && treeMap.compare_internal(first, toKey) >= 0)
            throw(new NoSuchElementException());
        return first;
    }

	public Object firstKey() {
		synchronized (this.$lock_M) {
			TreeMap_Entry e/*F=this.M*/ = fromStart ? treeMap.firstEntry_internal() : treeMap.getCeilEntry_internal(fromKey);
			Object first = TreeMap.key(e);
			if (!toEnd && treeMap.compare_internal(first, toKey) >= 0)
			    throw(new NoSuchElementException());
			return first;
		}
	}

    public Object lastKey_internal() {
    TreeMap_Entry e/*F=this.M*/ = toEnd ? treeMap.lastEntry_internal() : treeMap.getPrecedingEntry_internal(toKey);
        Object last = TreeMap.key(e);
        if (!fromStart && treeMap.compare_internal(last, fromKey) < 0)
            throw(new NoSuchElementException());
        return last;
    }

	public Object lastKey() {
		synchronized (this.$lock_M) {
			TreeMap_Entry e/*F=this.M*/ = toEnd ? treeMap.lastEntry_internal() : treeMap.getPrecedingEntry_internal(toKey);
			Object last = TreeMap.key(e);
			if (!fromStart && treeMap.compare_internal(last, fromKey) < 0)
			    throw(new NoSuchElementException());
			return last;
		}
	}

    /*atomic(M)*/ private transient Set entrySet/*L=this.M*/ = new TreeMap_EntrySetView/*L=this.M*/(this, this.$lock_M);

    public Set/*L=this.M*/ entrySet_internal() {
        return entrySet;
    }

	public Set entrySet() {
		synchronized (this.$lock_M) {
			return entrySet;
		}
	}

    public SortedMap/*M=this.M*/ subMap_internal(Object fromKey, Object toKey) {
        if (!inRange2_internal(fromKey))
            throw new IllegalArgumentException("fromKey out of range");
        if (!inRange2_internal(toKey))
            throw new IllegalArgumentException("toKey out of range");
        return new TreeMap_SubMap/*M=this.M*/(treeMap, fromKey, toKey, this.$lock_M);
    }

	public SortedMap subMap(Object fromKey, Object toKey) {
		synchronized (this.$lock_M) {
			if (!inRange2_internal(fromKey))
			    throw new IllegalArgumentException("fromKey out of range");
			if (!inRange2_internal(toKey))
			    throw new IllegalArgumentException("toKey out of range");
			return new TreeMap_SubMap/*M=this.M*/(treeMap, fromKey, toKey, this.$lock_M);
		}
	}

    public SortedMap/*M=this.M*/ headMap_internal(Object toKey) {
        if (!inRange2_internal(toKey))
            throw new IllegalArgumentException("toKey out of range");
        return new TreeMap_SubMap/*M=this.M*/(treeMap, fromStart, fromKey, false, toKey, this.$lock_M);
    }

	public SortedMap headMap(Object toKey) {
		synchronized (this.$lock_M) {
			if (!inRange2_internal(toKey))
			    throw new IllegalArgumentException("toKey out of range");
			return new TreeMap_SubMap/*M=this.M*/(treeMap, fromStart, fromKey, false, toKey, this.$lock_M);
		}
	}

    public SortedMap/*M=this.M*/ tailMap_internal(Object fromKey) {
        if (!inRange2_internal(fromKey))
            throw new IllegalArgumentException("fromKey out of range");
        return new TreeMap_SubMap/*M=this.M*/(treeMap, false, fromKey, toEnd, toKey, this.$lock_M);
    }

	public SortedMap tailMap(Object fromKey) {
		synchronized (this.$lock_M) {
			if (!inRange2_internal(fromKey))
			    throw new IllegalArgumentException("fromKey out of range");
			return new TreeMap_SubMap/*M=this.M*/(treeMap, false, fromKey, toEnd, toKey, this.$lock_M);
		}
	}

    boolean inRange_internal(Object key) {
        return (fromStart || treeMap.compare_internal(key, fromKey) >= 0) &&
               (toEnd     || treeMap.compare_internal(key, toKey)   <  0);
    }

	boolean inRange(Object key) {
		synchronized (this.$lock_M) {
			return (fromStart || treeMap.compare_internal(key, fromKey) >= 0) &&
			       (toEnd     || treeMap.compare_internal(key, toKey)   <  0);
		}
	}

    // This form allows the high endpoint (as well as all legit keys)
    private boolean inRange2_internal(Object key) {
        return (fromStart || treeMap.compare_internal(key, fromKey) >= 0) &&
               (toEnd     || treeMap.compare_internal(key, toKey)   <= 0);
    }

	private boolean inRange2(Object key) {
		synchronized (this.$lock_M) {
			return (fromStart || treeMap.compare_internal(key, fromKey) >= 0) &&
			       (toEnd     || treeMap.compare_internal(key, toKey)   <= 0);
		}
	}
}